﻿using System;
using System.Runtime.InteropServices;

namespace ACLAS
{
    public enum PowerType
    {
        PowerKeyDown = 0,
        PowerKeyUp = 1,
        PowerLose = 2,
        PowerRecovery = 3,
        PowerNormal = 4,
        PowerWaitToD3 = 5
    }

    public enum SLD_IOCTRL
    {
        GETDOTROW = 0,
        GETDOTCOL = 1,
        LIGHT_OP = 2,
        SET_CONTRAST = 3 ,
        SET_GRAPHMODE = 6 ,
        GET_CONTRAST = 7 ,
        GET_CONTRAST_RANGE = 8,
    }

    public enum PKD_IOCTRL
    {
        OPEN_DRAWER = 1,
        MONITOR_POWER = 2,
        GET_PRODUCT_ID = 3,
        SET_GPRS_POWER_CONTROL = 9,
        SET_M3_UPS_MODE = 10,
        SET_WAIT_TO_D3 = 82,
        WAIT_TO_D3 = 83,
        GET_CPU_TEMP = 100,
        GET_CPU_SPEED = 101,
        GET_CPU_IDLE = 102
    }

    public class WINAPI
    {
        public const UInt32 OPEN_EXISTING = 3;
        public const UInt32 GENERIC_READ = 0x80000000;
        public const UInt32 GENERIC_WRITE = 0x40000000;
        public const Int32 INVALID_HANDLE_VALUE = -1;
        public const uint POWER_NAME = 1;

        [DllImport("coredll.dll")]
        public static extern bool DeleteObject(IntPtr hObject);

        [DllImport("tvout.dll")]
        public static extern int GetCPUs();

        [DllImport("tvout.dll")]
        public static extern void
        SetThreadCPU(
           int dwProcessor
        );

        [DllImport("tvout.dll")]
        public static extern void
        SetProcessCPU(
           int dwProcessor
        );

        [DllImport("tvout.dll")]
        public static extern int
        GetThreadCPU();

        [DllImport("tvout.dll")]
        public static extern int
        GetProcessCPU();

        [DllImport("tvout.dll")]
        public static extern void
        DebugMsg(
           string msg
        );


    }

    public enum POWER_STATE : uint
    {
        D0 = 0,
        D1,
        D2,
        D3,
        D4
    }

}
