﻿using System;
using System.Collections.Generic;
using System.Text;

namespace ACLAS
{
    public static class  Buzzer
    {
       private static Device BuzDrv = new Device("BUZ1:", WINAPI.GENERIC_WRITE);   // 打開驅動裝置類別
       private static Boolean IsOpen = false;

       public static Boolean Open()
       {
           IsOpen = BuzDrv.Open();
           return IsOpen;  
       }

       public static void Close()
       {
           if (IsOpen) 
              BuzDrv.Close();   
       }

       public static void SoundOut(UInt16[] buf)
       {
           if (IsOpen)
           {
               SoundCmd.Make(buf);  
               BuzDrv.Write(SoundCmd.playbuf ,  SoundCmd.playbuf.Length); 
           }
       }
    }

/*
       typedef struct
       {
	      WORD  times;   // 循環次數
	      WORD  freq;    // 頻率
	      WORD  onTime;  // 開長度
  	      WORD  offTime; // 關長度
       } SoundCmd;
*/
    public static class SoundCmd
    {
        private static UInt16 times;
        private static UInt16 freq;
        private static UInt16 onTime;
        private static UInt16 offTime;
        public  static Byte[] playbuf=null;

        private static void Put(UInt16[] buf , int idx)
        {
            times = buf[idx];
            freq = buf[idx+1];
            onTime = buf[idx+2];
            offTime = buf[idx+3];
        }

        private static void Get(Byte[] buf, int idx)
        {
            CovTool.UInt16ToByte(times, buf, idx);
            CovTool.UInt16ToByte(freq, buf, idx+2);
            CovTool.UInt16ToByte(onTime, buf, idx + 4);
            CovTool.UInt16ToByte(offTime, buf, idx + 6);  
        }

        public static void Make(UInt16[] sound)
        {
            int len = sound.Length / 4;
            if (len > 0)
            {
                playbuf = new Byte[len * 8];
                for (int i = 0; i < len; i++)
                {
                    Put(sound, i * 4);
                    Get(playbuf, i * 8);
                }
            }
        }
    }
}
