﻿using System;
using System.Runtime.InteropServices;
using System.Threading;

namespace ACLAS
{
    // Support print from IE image file Download
    public class IEClass
    {
        private const String DllName = "TvOut.dll";

        [DllImport(DllName)]
        private static extern bool InitIEDownLoadMsgQ();
        [DllImport(DllName)]
        private static extern IntPtr GetIEDownLoadMsgQ();

        private Thread thd=null;
        public event EventHandler OnFileDownLoad = null;

        private String m_file;

        public String FileName
        {
            get
            {
                return m_file;
            }
        }

        public bool Open()
        {
            bool rc = InitIEDownLoadMsgQ();
            if (rc)
            {
                thd = new Thread(Main);
                thd.Start(); 
            }
            return rc;
        }

        private void Main()
        {
            while (true)
            {
                m_file = Marshal.PtrToStringUni(GetIEDownLoadMsgQ());

                if (m_file == null)
                {
                    Thread.Sleep(100);  
                }
                else
                {
                    if (OnFileDownLoad != null)
                    {
                        OnFileDownLoad.Invoke(this, null);
                    }
                }
            }
        }

        public void Close()
        {
            if (thd != null)
            {
                thd.Abort();
                Thread.Sleep(200);  
            }
        }

    }
}
