﻿using System;
using System.Drawing;
using System.Windows.Forms;
using Microsoft.Win32;
using System.Runtime.InteropServices;
using System.Threading;

namespace AutoStartDemo
{
    public partial class Form1 : Form
    {
        RegistryKey InitKey = Registry.LocalMachine.OpenSubKey("init",true);
        RegistryKey ShellKey = Registry.LocalMachine.CreateSubKey(@"SOFTWARE\Microsoft\Shell");
        RegistryKey AutoHideKey;
        RegistryKey OnTopKey;

        myMessageBox MsgBox = new myMessageBox();

        Thread thd = null;

        [DllImport("coredll.dll")]
        private static extern void SignalStarted(uint dw);


        public Form1()
        {
            InitializeComponent();
        }

        private void TurnOffTaskBar()
        {
            Thread.Sleep(2000);  
            FullScreenClass.SetFullScreen(true);
            thd = null;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Size = new Size(Screen.PrimaryScreen.Bounds.Width, Screen.PrimaryScreen.Bounds.Height);
            BackColor = Color.DarkBlue;
            plMenu.Location = new Point((Width - plMenu.Width) / 2, (Height - plMenu.Height) / 2);

            TopMost = true; 

            AutoHideKey =  ShellKey.CreateSubKey("AutoHide");
            OnTopKey = ShellKey.CreateSubKey("OnTop");

            // Signal to WINCE my Application is Run!
            SignalStarted(49);

            // Hide Task Bar 
            FullScreenClass.SetFullScreen(true); 

            // Create a thread Hide Task Bar After 2 second 
            thd = new Thread(TurnOffTaskBar);
            thd.Start(); 
        }

        private void Install()
        {
           // Get your Application file location and file name
           string appfile = System.Reflection.Assembly.GetExecutingAssembly().GetName().CodeBase;
           byte[] Depend50 = new byte[] { 20, 0, 30, 0, 49, 0 };
           InitKey.SetValue("Depend50" , Depend50 , RegistryValueKind.Binary);
           byte[] Depend49 = new byte[] { 20, 0, 30, 0};
           InitKey.SetValue("Depend49", Depend49, RegistryValueKind.Binary);
           // Registry to WINCE
           InitKey.SetValue("Launch49", appfile , RegistryValueKind.String);
           AutoHideKey.SetValue(null, 1, RegistryValueKind.DWord);
           OnTopKey.SetValue(null, 0 , RegistryValueKind.DWord); 
           InitKey.Flush(); 
        }

        private void Uninstall()
        {
            byte[] Depend50 = new byte[] { 20, 0, 30, 0 };
            InitKey.SetValue("Depend50", Depend50, RegistryValueKind.Binary);
            InitKey.DeleteValue("Launch49");
            InitKey.DeleteValue("Depend49");
            AutoHideKey.SetValue(null, 0, RegistryValueKind.DWord);
            OnTopKey.SetValue(null, 1, RegistryValueKind.DWord); 
            InitKey.Flush();  
        }

        private void btInsatll_Click(object sender, EventArgs e)
        {
            Install();
            MsgBox.ShowMsg("\r\n\r\nAuto Start Insatll OK!");
        }

        private void btUninstall_Click(object sender, EventArgs e)
        {
            Uninstall();
            MsgBox.ShowMsg("\r\n\r\nAuto Start Uninsatll OK!");
        }

        private void btExit_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void Form1_Closed(object sender, EventArgs e)
        {
            InitKey.Close();

            if (thd != null)
            {
                thd.Abort(); 
            }
            FullScreenClass.SetFullScreen(false);  
        }
    }

    public class FullScreenClass
    {
        public const int SW_HIDE = 0x00;
        public const int SW_SHOW = 0x0001;
        [DllImport("coredll.dll", EntryPoint = "FindWindow")]
        private static extern IntPtr FindWindow(string lpWindowName, string lpClassName);
        [DllImport("coredll.dll", EntryPoint = "ShowWindow")]
        private static extern bool ShowWindow(IntPtr hwnd, int nCmdShow);
        
        public static bool SetFullScreen(bool fullscreen)
        {
            IntPtr Hwnd = FindWindow("HHTaskBar", null);
            if (Hwnd == IntPtr.Zero) return false;
            if (fullscreen)
            {
                ShowWindow(Hwnd, SW_HIDE);
            }
            else
            {
                ShowWindow(Hwnd, SW_SHOW);
            }
            return true;
        }
    }
}