﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;

namespace Com3Test
{
    public partial class Form1 : Form
    {
        private void SendProc()
        {
            serialPort1.WriteLine("WinCE " + serialPort1.PortName + " Test OK!\r\n");
        }

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            serialPort1.BaudRate = 4800; 
            serialPort1.PortName = "COM1";

            cbPort.Text = "COM3";
            cbBaud.Text = "9600";
            SwitchPort();
           
            timer1.Enabled = true;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            SendProc();
        }

        private void SwitchPort()
        {
            bool setup = false;
            String PortName = cbPort.Text;
            String curPort = serialPort1.PortName;
            try
            {
                int Baud = Convert.ToInt32(cbBaud.Text);

                if (serialPort1.PortName.CompareTo(PortName) != 0)
                {
                    tbLog.Text += "Port : " + PortName + "\r\n";
                    setup = true;
                }

                if (serialPort1.BaudRate != Baud)
                {
                    tbLog.Text += "Baud Rate : " + Baud + "\r\n";
                    setup = true;
                }

                if (setup)
                {
                    if (serialPort1.IsOpen)
                        serialPort1.Close();

                    serialPort1.PortName = PortName;
                    serialPort1.BaudRate = Baud;

                    serialPort1.Open();
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("Error! " + ex.Message);
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            int n;
            String s;

            s = "";
            if ((n = serialPort1.BytesToRead) != 0)
            {
                for (int i = 0; i < n; i++)
                {
                    s += (Char)serialPort1.ReadByte();
                }
                tbLog.Text += s;
            }
        }

        private void cbBaud_TextChanged(object sender, EventArgs e)
        {
            if (timer1.Enabled)
                SwitchPort();
        }

        private void cbPort_TextChanged(object sender, EventArgs e)
        {
            if (timer1.Enabled)
                SwitchPort();
        }
    }
}