﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using ACLAS;

namespace CusTouchTest
{
    public partial class Form1 : Form
    {
        private CusTouch m_touch = new CusTouch();
        private Bitmap[] bmp = new Bitmap[6];
        private Color[] m_tchcolor = new Color[] { Color.Red , Color.Blue , Color.Green , Color.Yellow , Color.Pink , Color.Black };

        private Point[] m_tch_point = new Point[5];

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

            if (!TVout.Open())
            {
                MessageBox.Show("TV out Init Error!");
                Close();
                return;
            }
            
            if (!m_touch.Open())
            {
                MessageBox.Show("Open Custom Touch Driver Error!"); 
                Close();
                return;
            }

            m_touch.OnMouseDown += new EventHandler(m_touch_OnMouseDown);
            m_touch.OnMouseUp += new EventHandler(m_touch_OnMouseUp);
            m_touch.OnMouseMove += new EventHandler(m_touch_OnMouseMove); 

            for (int i=0;i<6;i++)
            {
                bmp[i] = new Bitmap(100, 100);

                using (Graphics gr = Graphics.FromImage(bmp[i]))
                {
                    gr.Clear(Color.Black);
                    gr.FillEllipse(new SolidBrush(m_tchcolor[i]), new Rectangle(0, 0, 100, 100));   
                }
            }
        }

        void m_touch_OnMouseMove(object sender, EventArgs e)
        {
            TouchEventArgs te = (TouchEventArgs)e;
            Point pt = m_tch_point[te.ID];
                        
        }

        void m_touch_OnMouseUp(object sender, EventArgs e)
        {
            TouchEventArgs te = (TouchEventArgs)e;
            Point pt = m_tch_point[te.ID];
            TVout.TvDrawImage(bmp[5], pt.X , pt.Y , 100, 100 , TvOutDrawMode.SRCERASE);
        }

        void m_touch_OnMouseDown(object sender, EventArgs e)
        {
            TouchEventArgs te = (TouchEventArgs)e;
            m_tch_point[te.ID] = new Point(te.X - 50, te.Y - 50);
            TVout.TvDrawImage(bmp[te.ID], te.X - 50 , te.Y - 50, 100, 100 , TvOutDrawMode.SRCPAINT);
        }

        private void Form1_Closed(object sender, EventArgs e)
        {
            m_touch.Close();
            TVout.Close();
        }

        private void btExit_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void btTest_Click(object sender, EventArgs e)
        {
        }




    }
}