﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Threading;
using System.Windows.Forms;

namespace Demo
{
    public class TLog
    {
        private string logfilename;
        private string logpath=@"\RfidLog";
        private FileStream fs;
        private StreamWriter sw;        

        public TLog()
        {
            if (!Directory.Exists(logpath))
                 Directory.CreateDirectory(logpath);
        }

        ~TLog()
        {
            //
            
        }

        private string GetLogPath()
        {
            return logpath + @"\Log" +
                string.Format("{0,2:00}", DateTime.Now.Hour) +
                string.Format("{0,2:00}", DateTime.Now.Minute) +
                string.Format("{0,2:00}", DateTime.Now.Second) + ".log";
        }

        public void setlogfile(string filename)
        {
            if (filename.Trim() != "")
            {
                logfilename = filename;
            }
            else
            {
                logfilename = GetLogPath();
            }            
            fs = new FileStream(logfilename, FileMode.OpenOrCreate);
            sw = new StreamWriter(fs);
        }

        
        public void addLog(string msg)
        {
            if (logfilename == "") return;

            fs.Seek(0, SeekOrigin.End);
            try
            {
               // msg = DateTime.Now.ToLongDateString() + " " + DateTime.Now.ToShortTimeString() + ":" + msg;
                sw.WriteLine(msg);
                sw.Flush();
            }
            finally
            {
                //
            }
        }

        public void Closefs()
        {
            //sw.Close();
            fs.Close();
        }
    }

    public class CommonLowerc
    {
        public enum IOCtrl
        {
            ReadCard = 1,
            Turn_OFF = 2
        }

        private int op = 0;                  
       // private RFIDDriver RFID;
        private const int DataLen = 26;
        private Byte[] inBuf = new Byte[DataLen];     //发送buf
        private Byte[] OutBuf = new Byte[DataLen];    //返回buf
        private int rsize = 0;
        private Device RfidCard = new Device("RID1:", 0);   // 打開驅動裝置類別
        private TLog log = new TLog();

        public CommonLowerc()
        {
        }

        public int openport()
        {
            if (op > 0) return 1;

            if (RfidCard.Open())
            {
                op++;
                log.setlogfile("");
                return 0;
            }
            else
            {                             
                return -1;
            }        	
        }

        public void closeport()
        {
            if (op > 0)
            {
                log.Closefs();
                RfidCard.Close();
                op = 0;
            }
        }

        public bool Active()
        {
            return (op > 0);
        }
        
        //Stx预留，暂时不管
        //SndStrA包含指令、数据长度、数据内容
        //buf输出
        //len输入长度及输出长度
        public int SendPackage(Byte Stx, Byte[] SndStrA, Byte[] buf, int[] len)
        {
            string s;
            byte rc = 1;
            int k = len[0];

            if (op == 0) return -1;

            inBuf[0] = 0;  // reserve 
            inBuf[1] = (Byte)SndStrA[0];  // 命令
            inBuf[2] = (Byte) k;   // 長度

            if (k > 22) return rc;  // input data length too big

            for (int i = 0; i < k; i++)
                inBuf[i + 3] = SndStrA[i+2];

            s = "CMD:";
            for (int i = 0; i < k+2; i++)    //发送的数据
            {
                s += inBuf[i+1].ToString("X2")+" ";
            }

            log.addLog("send:" + s);

            rsize = 0;
            if (RfidCard.IOControl((int)IOCtrl.ReadCard, inBuf, DataLen, OutBuf, DataLen, ref rsize))
            {
                s = "";
                rc = 0;      
                len[0] = OutBuf[2];
                  
                for (int i = 0; i < len[0] ; i++)
                {
                    buf[i] = OutBuf[3 + i];
                    s += (Convert.ToString(buf[i], 16).PadLeft(2, '0')).ToUpper() + " ";
                }
                log.addLog("recv: len->" + len[0].ToString() + ":" + s);
            }
            else
            {
                log.addLog("send->fail");
                rc = 2;
            }

            return rc;

        }
        

    }

}
