﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Demo
{
    static class CovTool
    {
        public static String HexString(Byte[] buf, int index, int len)
        {
            StringBuilder sb = new StringBuilder();
            for (int i = 0; i < len; i++)
                sb.Append(buf[index + i].ToString("X2"));
            return sb.ToString();
        }

        public static int toInt(Byte[] buf, int index)
        {
            int val = 0;
            for (int i = 0; i < 4; i++)
            {
                val <<= 8;
                val |= buf[index + 3 - i];
            }
            return val;
        }

        public static void IntToByte(int val , Byte[] buf, int idx)
        {
            for (int i = 0; i < 4; i++)
            {
                buf[idx + i] = (Byte) val;
                val >>= 8;
            }
        }

        public static void UIntToByte(UInt32 val, Byte[] buf, int idx)
        {
            for (int i = 0; i < 4; i++)
            {
                buf[idx + i] = (Byte)val;
                val >>= 8;
            }
        }

        public static void UInt16ToByte(UInt16 val, Byte[] buf, int idx)
        {
                buf[idx]   = (Byte) val;
                buf[idx+1] = (Byte) (val >> 8);
        }

        public static String toString(Byte[] buf, int index, int len)
        {
            StringBuilder s = new StringBuilder("Mag Track2:");

            for (int i = 0; i < len; i++)
            {
                Byte b = buf[index + i];
                if (b >= 0x20)
                    s.Append((Char)b);
            }
            return s.ToString();
        }
    }
}
