﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace Demo
{
    // 裝置類別 by Jacky
    public class Device
    {
        [DllImport("coredll.dll")]      //coredll
        public static extern bool WriteFile(
        System.IntPtr h_comm,
        Byte[] text,
        int length,
        ref   int length2,
        int overlap
        );

        [DllImport("coredll.dll")]
        public static extern bool ReadFile(
        System.IntPtr h_comm,
        Byte[] text,
        int length,
        ref int length2,
        int overlap
        );

        [DllImport("coredll.dll")]
        public static extern bool DeviceIoControl(
        System.IntPtr h_comm,
        int code,
        Byte[] inBuf,
        int InBufSize,
        Byte[] outBuf,
        int outBufSize,
        ref int BytesReturned,
        int overlap
        );

        [DllImport("coredll.dll")]
        public static extern System.IntPtr CreateFile(
        string FileName,                                         //   file   name 
        uint DesiredAccess,                                   //   access   mode 
        uint ShareMode,                                           //   share   mode 
        uint SecurityAttributes,                         //   Security   Attributes 
        uint CreationDisposition,                       //   how   to   create 
        uint FlagsAndAttributes,                         //   file   attributes 
        int hTemplateFile                                       //   handle   to   template   file 
        );

        [DllImport("coredll.dll")]
        public static extern bool CloseHandle(System.IntPtr h_comm);

        private String DeviceName;
        private System.IntPtr Handle;
        private uint DeviceMode;
        private bool isOpen = false;

        public Device(String name, uint mode)
        {
            DeviceName = name;
            DeviceMode = (uint)mode;
        }

        public Boolean IOControl(int code, Byte[] inbuf, int insize, Byte[] obuf, int osize, ref int rsize)
        {
            rsize = 0;
            return DeviceIoControl(Handle, code, inbuf, insize, obuf, osize, ref rsize, 0);
        }

        public Boolean Open()
        {
            if (isOpen)
            {
                Close();
            }
            Handle = CreateFile(DeviceName, DeviceMode, 0, 0, WINAPI.OPEN_EXISTING, 0, 0);
            isOpen = ((int)Handle != WINAPI.INVALID_HANDLE_VALUE);
            return isOpen;
        }

        public Boolean Close()
        {
            isOpen = false;
            return CloseHandle(Handle);
        }

        public bool Write(Byte[] buf, int size)
        {
            int rsize = 0;
            return WriteFile(Handle, buf, size, ref rsize, 0);
        }

        public int Read(Byte[] buf, int size)
        {
            int rsize = 0;
            ReadFile(Handle, buf, size, ref rsize, 0);
            return rsize;
        }
    }

    public static class WINAPI
    {
        public const UInt32 OPEN_EXISTING = 3;
        public const UInt32 GENERIC_READ = 0x80000000;
        public const UInt32 GENERIC_WRITE = 0x40000000;
        public const Int32 INVALID_HANDLE_VALUE = -1;
    }

}
