﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Threading;

namespace Demo
{
    public partial class Form1 : Form
    {
        RfidUpperc rfidc = new RfidUpperc();
        Byte[] Cardno = new Byte[20];
        Thread sThread;
        Byte ThreadNum = 0;
        des51 des = new des51();
        Byte[] sCommPass = { 0x11, 0x22, 0x33, 0x44, 0x55, 0x66, 0x77, 0x88 };
        Byte[] Memno = new Byte[40];
        uint[] Opsn = new uint[1];
        uint[] Money = new uint[1];
        ulong ManaPsw;
        byte[] ecrflag ={ 0x11, 0x22, 0x33, 0x44, 0x55, 0x66, 0x77, 0x88 };
        Byte[] pMemno ={ 0x12, 0x34, 0x56, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF };
        Byte[] ManaMemno ={ 0x99, 0x91, 0x23, 0x45, 0x6F, 0xFF, 0xFF, 0xFF };
        //--------------------------------------------------
        private Device iButton = new Device("HDQ1:", WINAPI.GENERIC_WRITE | WINAPI.GENERIC_READ);   // 打開驅動裝置類別
        private Device MagCard = new Device("MAG1:", WINAPI.GENERIC_READ);   // 打開驅動裝置類別
       // private RFIDDriver RFID1;

        private Thread thd=null;
        private Thread Magthd=null;

        private Boolean Connect = false;
        private Byte [] buf = new Byte[9];

        private Byte[] MagData = new Byte[1024];

        private MagCardHeader  magH;

        delegate void TextCallBack(String msg);

        public Form1()
        {
            InitializeComponent();
        }

        private Boolean ReadSerialNo()
        {
            int rsize;
            Byte data;

            buf[0] = 0x33;
            for (int i = 0; i < 5 ; i++)
            {
                rsize = iButton.Read(buf, 9);
                if (rsize == 9)
                    break;
            }

            data = 0xff;

            for (int i = 7; i > 1; i--)
            {
                data &= buf[i];
            }

            return (data!=0xff);
        }

        private void ShowData()
        {
            Int64 val = 0;
            for (int i = 7; i > 1; i--)
            {
                val = val * 256 + buf[i];
            }
            String sno = val.ToString("D15");

            ShowLog("FAMILY CODE:" + buf[1] + "\r\n");
            ShowLog("Serial Number:" + sno + "\r\n");
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            if (iButton.Open())
            {
                ShowLog("Open iButton Device OK!\r\n");
            }
            else
            {
                MessageBox.Show("Open iButton Device Error!");
                Close();
            }

            if (MagCard.Open())
            {
                ShowLog("Open Mag Card Device OK!\r\n");
            }
            else
            {
                MessageBox.Show("Open Mag Card Device Error!");
                Close();
            }

           // RFID1 = new RFIDDriver(this);

            //if (RFID1.Open())
            //{
            //    ShowLog("Open RFID Card Device OK!\r\n");
            //}
            //else
            //{
            //    MessageBox.Show("Open RFID Card Device Error!");
            //    Close();
            //}

            //------------------------------------------------------------
            if (Buzzer.Open())
            {
                ShowLog("Open Buzzer Driver OK!\r\n");
            }
            else
            {
                MessageBox.Show("Open Buzzer Device Error!");
                Close();
            }

            Magthd = new Thread(MagProc);
            Magthd.Start();   

            thd = new Thread(iButtonProc);
            thd.Start();

           // String ProductClassCode="";
           // int SerialNo=0;
           // String DriverVersion="";

            Openport_Click(null,null);

            //--------------------------------------------------------
            //if (RFID1.GetInfo(ref SerialNo, ref ProductClassCode, ref DriverVersion))
            //{
            //    ShowLog("RFID Reader Product Class Code : 0x" + ProductClassCode + "\r\n");
            //    ShowLog("RFID Reader Product Serial Number : " + SerialNo + "\r\n");
            //    ShowLog("RFID Reader Driver Version : " + DriverVersion + "\r\n");
            //}
            //else
            //{
            //    ShowLog("RFID Reader GetInfo() Error!\r\n");
            //}
            //RFIDStart();
        }

        private void MagProc()
        {
            Boolean go = true;
            int len;

            while (go)
            {
                len = MagCard.Read( MagData , MagData.Length);
                if (len != 0)
                {
                    magH = new MagCardHeader(MagData);
                    ShowLog(magH.Mag2 + "\r\n"); 
                }
                Thread.Sleep(100);  
            }
        }

        private void iButtonProc()
        {
            Boolean rc;

            while (true)
            {
               rc = ReadSerialNo();

               if (Connect)
               {
                   if (!rc)
                   {
                       ShowLog("iButton disconnect...!\r\n");
                       Connect = false;
                   }
               }
               else
               {
                   if (rc)
                   {
                       ShowData(); 
                       Connect = true;
                   }
               }
               Thread.Sleep(50);  
            }
        }

        public void ShowLog(String msg)
        {
          //  tbLog.Text += msg;
            if (tbLog.InvokeRequired)
            {
                TextCallBack tb = new TextCallBack(ShowLog);
                Invoke(tb, new Object[] { msg });
            }
            else
            {
                tbLog.Text += msg;
               // tbLog.Select(tbLog.TextLength, 0);
               // tbLog.ScrollToCaret();
            }
        }

        private void btExit_Click(object sender, EventArgs e)
        {
            ThreadNum = 0;
            if (sThread != null)
                sThread.Abort();

            if (rfidc.Active())
                rfidc.ClosePort();

            if (Magthd != null)
                Magthd.Abort();

            if (thd != null)
                thd.Abort();

            iButton.Close();
            MagCard.Close();
            Buzzer.Close();


            Close();
        }

        private void btRead_Click(object sender, EventArgs e)
        {
            tbLog.Text = ""; 
        }

        private void Form1_Closed(object sender, EventArgs e)
        {
            if (thd != null)
            {
                Magthd.Abort();  
            }
            if (Magthd != null)
            {
                Magthd.Abort();  
            }

            Thread.Sleep(100);  // 等待所有執行緒被關閉

            // 關閉所有打開的設備
            iButton.Close();   
            MagCard.Close();

            //RFID1.Close();

            Buzzer.Close();  
        }

   

        //-------------------------------------------------------------------------------
        private void excuteproc()
        {
            int ret = 0;
            int i;
            Byte[] cardbuf = new Byte[8];
            string s;
            UInt16[] RFIDSound = new UInt16[] { 1 , 2600, 100 , 40 , };
            while (true)
            {
                if (ThreadNum == 1)
                {
                    ret = rfidc.ReadCardNo(Cardno);
                    if (ret == 0)
                    {                        
                        s = "";
                        for (i=0;i<4;i++)
                            s += Cardno[i].ToString("X2");                        
                        ShowLog("Card No." + s + "\r\n");
                                
                        des.des_key(des.dc, sCommPass);
                        for (i = 0; i < 4; i++)
                            cardbuf[i] = 0;
                        for (i = 4; i < 8; i++)
                            cardbuf[i] = Cardno[i - 4];

                        des.des_enc(des.dc, cardbuf, 1);
                        //ret = rfidc.ReadCardAmount(cardbuf, Memno, Opsn, Money);
                        ShowLog("start read...\r\n");
                        ret = rfidc.ReadCardAmountEcrflag(cardbuf, Memno, Opsn, Money, ecrflag);
                        if (ret == 0)
                        {
                            s = "";
                            for (i = 0; i < 40; i++)
                                s += Memno[i].ToString();

                            ShowLog("Mem Card: " + s + "\r\n");
                            ShowLog("Money: " + Money[0].ToString() + "\r\n");
                            ThreadNum = 10;
                        }
                        else
                        {
                            ThreadNum = 11;
                            ShowLog("Read Card Fail..."+ ret.ToString()+"\r\n ");
                        }

                    }
                }
                if (ThreadNum == 2)
                {
                    ret = rfidc.aclas_set_compsw(sCommPass);
                    if (ret == 0)
                    {
                        ShowLog("Set_compsw ok \r\n ");
                        ThreadNum = 10;
                    }
                    else
                    {
                        ShowLog("Set_compsw fail " + ret.ToString() + "\r\n ");
                        ThreadNum = 11;
                    }
                }
                if (ThreadNum == 3)
                {
                    ret = rfidc.WriteCard(Money);
                    if (ret == 0)
                    {
                        ShowLog("WriteCard Ok...\r\n ");
                        ThreadNum = 10;
                    }
                    else
                    {
                        ShowLog("WriteCard Fail..." + ret.ToString() + "\r\n ");
                        ThreadNum = 11;
                    }
                }
                if (ThreadNum == 4)
                {
                    ret = rfidc.ReadManaCard(ManaPsw);
                    if (ret == 0)
                    {
                        ShowLog("read man card ok...\r\n ");
                        ThreadNum = 10;
                    }
                    else
                    {
                        ShowLog("Fail re:" + ret.ToString() + "\r\n ");
                        ThreadNum = 11;
                    }
                    
                }
                if (ThreadNum == 5)
                {
                    ret = rfidc.ReadCardNo(Cardno);
                    if (ret == 0)
                    {
                        s = "";
                        for (i = 0; i < 4; i++)
                            s += Cardno[i].ToString("X2");
                        ShowLog("Card No." + s + "\r\n");

                        des.des_key(des.dc, sCommPass);
                        for (i = 0; i < 4; i++)
                            cardbuf[i] = 0;
                        for (i = 4; i < 8; i++)
                            cardbuf[i] = Cardno[i - 4];
                        des.des_enc(des.dc, cardbuf, 1);
                        ret = rfidc.InitializeCard(cardbuf);
                        if (ret == 0)
                        {
                            ShowLog("Initialize User Card ok!\r\n");
                            ThreadNum = 10;
                        }
                        else
                        {
                            ShowLog("Initialize User Card fail!\r\n");
                            ThreadNum = 11;
                        }

                    }
                }
                if (ThreadNum == 6)
                {
                    ret = rfidc.ReadCardNo(Cardno);                    
                    if (ret == 0)
                    {
                        s = "";
                        for (i = 0; i < 4; i++)
                            s += Cardno[i].ToString("X2");
                        ShowLog("Card No." + s + "\r\n");
                        ManaPsw = 110;
                        ret = rfidc.InitialManaCard(ManaPsw);
                        if (ret == 0)
                        {
                            ShowLog("InitialManaCard ok!\r\n");
                            ThreadNum = 10;
                        }

                    }
                }
                if (ThreadNum == 7)
                {
                    ret = rfidc.ReadCardNo(Cardno);
                    if (ret == 0)
                    {
                        des.des_key(des.dc, sCommPass);
                        for (i = 0; i < 4; i++)
                            cardbuf[i] = 0;
                        for (i = 4; i < 8; i++)
                            cardbuf[i] = Cardno[i - 4];
                        des.des_enc(des.dc, cardbuf, 1);
                        //ret = rfidc.PublishCard(cardbuf, pMemno);
                        for (int j = 0; j < ecrflag.Length; j++)
                        {
                           // MessageBox.Show(ecrflag[j].ToString());
                        }
                        ret = rfidc.PublishCardEcrflag(cardbuf, pMemno, ecrflag);
                        if (ret == 0)
                        {
                            ShowLog("Publish User Card ok!\r\n");
                            ThreadNum = 10;
                        }

                    }
                }
                if (ThreadNum == 8)
                {
                    ret = rfidc.ReadCardNo(Cardno);
                    if (ret == 0)
                    {
                        ManaPsw = 110;
                        ret = rfidc.PublishManaCard(ManaPsw, ManaMemno);
                        if (ret == 0)
                        {
                            ShowLog("PublishManaCard ok!\r\n");
                            ThreadNum = 10;
                        }

                    }
                }

                if (ThreadNum == 10)
                {                
                    ThreadNum = 0;
                    Buzzer.SoundOut(RFIDSound);    
                }

                if (ThreadNum == 11)
                {                    
                    ThreadNum = 0;                    
                }

                if (ret == -1)
                {
                    ShowLog("exit thread!\r\n");
                    Thread.CurrentThread.Abort(); 
                }
                else
                {
                    Thread.Sleep(100);
                }
            }
        }


        private void SetCommPass_Click_1(object sender, EventArgs e)
        {
            ThreadNum = 2;
            if (sThread == null)
            {
                sThread = new Thread(new ThreadStart(excuteproc));
                sThread.Start();
            }
        }

        private void ReadCard_Click_1(object sender, EventArgs e)
        {
            ThreadNum = 1;
            if (sThread == null)
            {
                sThread = new Thread(new ThreadStart(excuteproc));
                sThread.Start();
            }
            
        }

        private void WriteCard_Click_1(object sender, EventArgs e)
        {
            Money[0] = 1000;
            ThreadNum = 3;
            if (sThread == null)
            {
                sThread = new Thread(new ThreadStart(excuteproc));
                sThread.Start();
            }
        }

        private void ReadManaCard_Click_1(object sender, EventArgs e)
        {          

            ManaPsw = Convert.ToUInt32(tbManaPass.Text);
            ThreadNum = 4;
            if (sThread == null)
            {
                sThread = new Thread(new ThreadStart(excuteproc));
                sThread.Start();
            }
        }

        private void InitUserCard_Click_1(object sender, EventArgs e)
        {
            ThreadNum = 5;
            if (sThread == null)
            {
                sThread = new Thread(new ThreadStart(excuteproc));
                sThread.Start();
            }
        }

        private void PublishUserCard_Click_1(object sender, EventArgs e)
        {
            string s=tbPubMemno.Text;
            for (int i=0; i<s.Length; i++)
            {
                Memno[i] = Convert.ToByte(s[i]); 
            }
        
            Money[0]=0;
            ThreadNum = 7;
            if (sThread == null)
            {
                sThread = new Thread(new ThreadStart(excuteproc));
                sThread.Start();
            }
        }

        private void InitManaCard_Click_1(object sender, EventArgs e)
        {
            ThreadNum = 6;
            if (sThread == null)
            {
                sThread = new Thread(new ThreadStart(excuteproc));
                sThread.Start();
            }
        }

        private void PublishManaCard_Click_1(object sender, EventArgs e)
        {
            ThreadNum = 8;
            if (sThread == null)
            {
                sThread = new Thread(new ThreadStart(excuteproc));
                sThread.Start();
            }
        }

        private void Openport_Click(object sender, EventArgs e)
        {
            switch (rfidc.SendPort())
            {
                case 0: ShowLog("Open RFID Card Device OK!\r\n"); break;
                case 1: ShowLog("RFID Card Device already open...\r\n"); break;
                case -1: ShowLog("Open RFID Card Device Error!\r\n"); break;
            }

        }

        private void Closeport_Click(object sender, EventArgs e)
        {
            rfidc.ClosePort();
            ShowLog("Thank you!\r\n");
        }

        private void EndThread_Click(object sender, EventArgs e)
        {
            ThreadNum = 0;
            if (sThread != null)
            {
                sThread.Abort();
                sThread = null;
            }
        }

        private void tabPage1_Click(object sender, EventArgs e)
        {

        }
    }

    public class  MagCardHeader
    {
        public int len1;
        public int len2;
        public int len3;
        public String Mag2;

        public MagCardHeader(Byte [] buf)
        {
            len1 = CovTool.toInt(buf, 0);
            len2 = CovTool.toInt(buf, 4);
            len3 = CovTool.toInt(buf, 8);
            if (len2 > 0)
               Mag2 = CovTool.toString(buf,140,len2); 
        }
    }

 
}