﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace Demo
{
    public class RfidUpperc
    {
            public struct RFID_ACCOUNT_T
            {
                    public ulong serno;           // 金额操作系列号
                    public ulong account;         // 当前金额
                    public Byte valid;            // 当前区的数据的有效性
            };

            public struct RFID_EXPEND_T
            {
                    public ulong exsum;
                    public Byte[] Date;//;
                    public Byte serNo;
                    public Byte vailed;
                    public RFID_EXPEND_T(ulong exsum1, Byte serNo1, Byte vailed1)
                    {
                        exsum = exsum1;
                        Date = new Byte[3];
                        serNo = serNo1;
                        vailed = vailed1;
                    }
            };

            public struct RFID_CARD_INFO_T             // 该结构保存的数据是卡片的基本信息，不提供给AP层使用
            {
            //    Byte ver;              // 卡片当前数据结构的版本
                    public Byte memsize;          // 卡片的容量
                    public Byte[] cardno;//        // 卡片的系列号
            //    Byte realcardno[7];    // 卡片的实际系列号(保存在卡片中的卡号)
            //    Byte ecrflag[5];       // ECR自定义数据
                    public RFID_ACCOUNT_T[] account;//  // 金额
                    public Byte nextopblock;      // 下一个操作的块
                    public ulong nextopserno;      // 下一个操作的序号
                    public RFID_EXPEND_T[] expend;//
                    public RFID_CARD_INFO_T(Byte memsize1, Byte nextopblock1, ulong nextopserno1)
                    {
                        memsize = memsize1;
                        nextopblock = nextopblock1;
                        nextopserno = nextopserno1;
                        cardno = new Byte[4];
                        account = new RFID_ACCOUNT_T[2];
                        expend = new RFID_EXPEND_T[2];
                    }
            };

            public struct RFID_OPERATE_T             // 该结构由AP层提供给底层程序，或由底层读取
            {
                    public Byte cmd;             // 操作命令
                    public Byte[] boss_pwd;//     // 老板的密码
                    public Byte opstatus;        // 当前操作状态
                    public Byte[] DateTime;//          // bcd
                    public Byte CardDataVer;     // 卡数据版本
                    public Byte mode;            // 操作模式
                    public Byte[] realcardno;//   // 当前卡的实际卡号(从卡片中读取)
                    public Byte[] ecrflag;//      // ECR自定义数据(从卡片中读取)
                    public ulong account;         // 当前卡的余额(从卡片中读取或AP层设置)
                    public ulong newexpend;       // 新的(要写入的)当前卡的当天交易金额.
                    public ulong expend;          // 当前卡的当天交易金额.
                    public ulong usr_psw;         // 用户密码
                    public RFID_OPERATE_T(Byte cmd1, Byte opstatus1, Byte CardDataVer1, Byte mode1, ulong account1, ulong newexpend1, ulong expend1,ulong usr_psw1)
                    {
                        cmd = cmd1;
                        opstatus = opstatus1;
                        CardDataVer = CardDataVer1;
                        mode = mode1;
                        account = account1;
                        newexpend = newexpend1;
                        expend = expend1;
                        usr_psw = usr_psw1;
                        boss_pwd = new Byte[4];
                        DateTime =new Byte[6];
                        realcardno = new Byte[7];
                        ecrflag = new Byte[5];
                    }
            };

            public struct RFID_PROC_T
            {
                    public Byte state;
                    public Byte retry;
                    public Byte[] dat;           // 接收缓冲区的地址
            //    RFID_BASE_MSG_T msg;        // 基本信息
                    public RFID_CARD_INFO_T cardinfo;  // 卡片信息
                    public RFID_OPERATE_T op;
                    public RFID_PROC_T(Byte state1, Byte retry1)
                    {
                        state=state1;
                        retry = retry1;
                        dat = new Byte[8];
                        cardinfo = new RFID_CARD_INFO_T(0, 0, 0);
                        op = new RFID_OPERATE_T(0, 0, 0, 0, 0, 0, 0, 0); 
                    }
            };

            const Byte RFID_SECTOR0       =      5;                // 必须大于0，因为需要使用3个块保存信息
            const Byte RFID_SECTOR1 = (RFID_SECTOR0 + 1);
            const Byte RF_BLK_STORE_NO = (0 + 4 * RFID_SECTOR0);    // 卡号和自定义信息
            const Byte RF_BLK_ACCOUNT_0 = (1 + 4 * RFID_SECTOR0);    // 金额1
            const Byte RF_BLK_ACCOUNT_1 = (2 + 4 * RFID_SECTOR0);    // 金额2
            const Byte RF_BLK_SECT0_PWD = (3 + 4 * RFID_SECTOR0);    // 密码
            const Byte RF_BLK_USRPSW = (0 + 4 * RFID_SECTOR1);    // 用户密码
            const Byte RF_BLK_EXPEND_0 = (1 + 4 * RFID_SECTOR1);    // 消费金额1
            const Byte RF_BLK_EXPEND_1 = (2 + 4 * RFID_SECTOR1);    // 消费金额2
            const Byte RF_BLK_SECT1_PWD = (3 + 4 * RFID_SECTOR1);    // 密码

            const Byte OK = 1;
            const Byte ERROR = 0;
            const int CardNoMaxLen       = 12;  // 卡号允许最多位数

            RfidMiddlec AMiddle;
            RFID_PROC_T rfid;
            Byte[] buf = new Byte[50];
            Byte[] buf_bck=new Byte[50];
            Byte[] parbuf=new Byte[50];
            Byte[] Size = new Byte[2];
            Byte RetVal;
            des51 des;
            Byte[] deskey ={0x41,0x31,0x42,0x32,0x43,0x33,0x44,0x34};

            public RfidUpperc()
            {
                AMiddle = new RfidMiddlec();
                rfid = new RFID_PROC_T(0,0);
                des = new des51();
                des.des_key(des.dc, deskey);
            }

            public int SendPort()
            {
                    return AMiddle.mopenport();
            }

            public int ClosePort()
            {
                    AMiddle.mcloseport();
                    return 0;
            }

            public bool Active()
            {
                return AMiddle.Active();
            }

            private Byte Mifs_Config()
            {
                    return AMiddle.mifs_set_config();//CancelFlagA);
            }

            private Byte  Mifs_Request(Byte mode,Byte[] TagType)
            {
                    return AMiddle.mifs_request(mode, TagType);//,CancelFlagA);
            }

            private Byte  Mifs_Anticoll2(Byte Encoll,Byte Bcnt,Byte[] SNR)           // 防止碰撞
            {
                return AMiddle.mifs_Anticoll2(Encoll, Bcnt, SNR);//,CancelFlagA);
            }

            private Byte  Mifs_Close()
            {
                return AMiddle.mifs_close();
            }

            private Byte  Mifs_Select(Byte[] Snt,Byte[] Size)
            {
                return AMiddle.mifs_select(Snt, Size);//,CancelFlagA);
            }
            private Byte  Mifs_AuthKey(Byte Mode,Byte SecNr,Byte[] Key)
            {
                return AMiddle.mifs_Authentication3(Mode, SecNr, Key);//,CancelFlagA);
            }

            private Byte  Mifs_Read(Byte Adr,Byte[] Data)               // 读取用户密码
            {
                return AMiddle.mifs_Read(Adr, Data);//,CancelFlagA);
            }

            private Byte  Mifs_Write(Byte Adr,Byte[] Data)
            {
                return AMiddle.mifs_Write(Adr, Data);//,CancelFlagA);
            }

            public Byte  Mifs_Buzzer(Byte Frequence,Byte Opentm,Byte Closetm,Byte Repcnt)
            {
                return AMiddle.mifs_buzzer(Frequence, Opentm, Closetm, Repcnt);//,CancelFlagA);
            }

            private Byte Beep_Buzzer(Byte Frequence,Byte Opentm,Byte Closetm,Byte Repcnt)
            {
                return AMiddle.mifs_buzzer(Frequence, Opentm, Closetm, Repcnt);
            }

            public Byte aclas_set_compsw(Byte[] psw)
            {
                return AMiddle.aclas_set_compass(psw);
            }

            public Byte aclas_set_bosspsw(Byte[] psw)
            {
                return AMiddle.aclas_set_bosspass(psw);
            }

            
            private void rfid_authsec(Byte sec,Byte[]  buf,Byte[] desCardno)
            {
                    RetVal=AMiddle.aclas_psw_auth(0, sec, desCardno);
            }

            private void memcpyz(int destindex, Byte[] dest, int srcindex, Byte[] srcb, int len)
            {
                int i;
                for (i = 0; i < len; i++)
                    dest[i + destindex] = srcb[i + srcindex];
//                srcb.CopyTo(
            }

            private int memcmpz(int destindex, Byte[] dest, int srcindex, Byte[] srcb, int len)
            {
                int i;
                for (i = 0; i < len; i++)
                {
                    if (dest[i + destindex] != srcb[i + srcindex])
                        break;
                }
                if (i == len) return 0;
                else return 1;
            }

            private void memsetz(Byte[] dest, Byte value, int len)
            {
                int i;
                for (i = 0; i < len; i++)
                    dest[i] = value;
            }

            private uint HIWORD(ulong value)
            {
                return (uint)(value >> 16);
            }

            private uint LOWORD(ulong value)
            {
                return (uint)(value - HIWORD(value) * 0x10000);
            }

            private Byte HIBYTE(uint value)
            {
                return (Byte)(value >> 8);
            }

            private Byte LOBYTE(uint value)
            {
                return (Byte)(value - HIBYTE(value) * 0x100);
            }

            private void des_enc(Byte[] buf,int index)
            {
                Byte[] tmpbuf = new Byte[8];
                memcpyz(0, tmpbuf, index, buf, 8);
                des.des_enc(des.dc, tmpbuf, 1);
                memcpyz(index, buf, 0, tmpbuf, 8);
            }

            private void des_dec(Byte[] buf, int index)
            {
                Byte[] tmpbuf = new Byte[8];
                memcpyz(0, tmpbuf, index, buf, 8);
                des.des_dec(des.dc, tmpbuf, 1);
                memcpyz(index, buf, 0, tmpbuf, 8);
            }

            private void rfid_authsec2(Byte sec, Byte[] buf, ulong bpsw)
            {
                    Byte i;
                    rfid.op.boss_pwd[0]=HIBYTE(HIWORD(bpsw));
                    rfid.op.boss_pwd[1]=LOBYTE(HIWORD(bpsw));
                    rfid.op.boss_pwd[2]=HIBYTE(LOWORD(bpsw));
                    rfid.op.boss_pwd[3]=LOBYTE(LOWORD(bpsw));
                    memcpyz(0,buf, 0,rfid.op.boss_pwd, 4);          // 商店老板的密码
                    memcpyz(4,buf,0, rfid.cardinfo.cardno, 4);       // 系列号
                    sec ^= 5;   //////!!!!!!!!!!!!!!
                    for(i=0;i<8;i++)
                    {
                            buf[i] ^= sec;
                    }
                    des_enc(buf,0);
                    sec ^= 5;
//                    MessageBox.Show(buf[0].ToString() + "," + buf[1].ToString() + "," + buf[2].ToString() + "," + buf[3].ToString() + "," + buf[4].ToString() + "," + buf[5].ToString());
                    RetVal=Mifs_AuthKey(0, sec, buf);
            //        RetVal=aclas_psw_auth(0, sec, desCardno);
            }

            //=============================================================================
            private void rfid_wrAccount(Byte block, Byte[] buf)
            {// 先填写金额，确保初始化完卡号，金额一定为0
                    // 设置金额1
                    ulong ltmp;
//                    MessageBox.Show("wrblk"+block.ToString());
                    rfid.op.account=rfid.op.newexpend;
            //	*((long  *)&buf[0]) = rfid.op.account;     // 金额   2
                    ltmp=rfid.op.account;
                    buf[0]=HIBYTE(HIWORD(ltmp));
                    buf[1]=LOBYTE(HIWORD(ltmp));
                    buf[2]=HIBYTE(LOWORD(ltmp));
                    buf[3]=LOBYTE(LOWORD(ltmp));
//                    MessageBox.Show("blk"+block.ToString()+"wrMny" +buf[0].ToString() + "," + buf[1].ToString() + "," + buf[2].ToString() + "," + buf[3].ToString());
                    memcpyz(4,buf, 0,rfid.cardinfo.cardno, 2);   // 卡序列号  6
//                    *((UINT16  *)&buf[6]) = (UINT16)(rfid.cardinfo.nextopserno >> 16);     //8 High 16 bits
                    buf[6] = HIBYTE((uint)(rfid.cardinfo.nextopserno >> 16));//08.0526
                    buf[7] = LOBYTE((uint)(rfid.cardinfo.nextopserno >> 16));
               //	*((long  *)&buf[8]) = ~rfid.op.account;     // 金额反    10
                    ltmp=~(rfid.op.account);
                    buf[8]=HIBYTE(HIWORD(ltmp));
                    buf[9]=LOBYTE(HIWORD(ltmp));
                    buf[10]=HIBYTE(LOWORD(ltmp));
                    buf[11]=LOBYTE(LOWORD(ltmp));
                    memcpyz(12,buf,2,rfid.cardinfo.cardno, 2);   // 卡序列号  14
//                    *((UINT16  *)&buf[14]) = (UINT16)(rfid.cardinfo.nextopserno);    // Low 16 bits 16
                    buf[14] = HIBYTE((uint)(rfid.cardinfo.nextopserno));
                    buf[15] = LOBYTE((uint)(rfid.cardinfo.nextopserno));
                    des_enc(buf,0);
                    des_enc(buf,8);
                    buf[16]=0;
                    RetVal=Mifs_Write(block, buf);    //2
//                    MessageBox.Show("wret"+RetVal.ToString());
            }
            //====================================
            private Byte rfid_checkAccount(Byte[] buf)
            {
                    des_dec(buf,0);          //2
                    des_dec(buf,8);          //10
//                    *((long  *)&buf[8]) = ~(*((long  *)&buf[8]));     // 金额反      10
                    buf[8] = (Byte)~buf[8];
                    buf[9] = (Byte)~buf[9];
                    buf[10] = (Byte)~buf[10];
                    buf[11] = (Byte)~buf[11];
                    if ((memcmpz(0, buf, 8, buf, 4) == 0)       // 检查金额是否相同       2    10
                            && (memcmpz(4,buf,0, rfid.cardinfo.cardno, 2) == 0)   // 卡序列号  6
                            && (memcmpz(12,buf,2,rfid.cardinfo.cardno, 2) == 0))   // 卡序列号  14
                    {
                            return OK;
                    }
                    else
                    {
                            return ERROR;
                    }
            }
            //====================================
            private Byte rfid_getAccount()
            {
                    Byte tmp;
                    ulong g;
                    tmp = 0;
                    if(rfid.cardinfo.account[0].valid>0)
                    {
                            if(rfid.cardinfo.account[1].valid>0)        // 两个数据均有效
                            {
                                    // 最高位,用作黑卡.剩31位.
                                    // 取相对更新的数据，原则上两个区的序号只会相差1，但是为了保险起见，认为两次错误的操作数间隔不会超过0x40000000
//                                    if((((long)(rfid.cardinfo.account[0].serno - rfid.cardinfo.account[1].serno)) & (~0x80000000L)) > 0x40000000L)
                                    g = (ulong)(((long)(rfid.cardinfo.account[0].serno - rfid.cardinfo.account[1].serno)) & (~0x80000000L));
//                                    MessageBox.Show(g.ToString());
                                    if(g > 0x40000000L)
                                    {
                                            tmp =1;
                                    }
                            }
                    }
                    else
                    {
                            if(rfid.cardinfo.account[1].valid>0)        // 第二个数据有效
                            {
                                    tmp = 1;
                            }
                            else        // 两个数据均无效(这种情况应该不会出现)
                            {
                                    rfid.op.account = 0;
                                    rfid.cardinfo.nextopblock = 0;
                                    rfid.cardinfo.nextopserno = 0;
                                    return ERROR;
                            }
                    }
                    if(tmp>0)
                    {
                            rfid.op.account = rfid.cardinfo.account[1].account;
                            rfid.cardinfo.nextopblock = 0;
                            rfid.cardinfo.nextopserno = (ulong)(rfid.cardinfo.account[1].serno + 1);
                    }
                    else
                    {
                            rfid.op.account = rfid.cardinfo.account[0].account;
                            rfid.cardinfo.nextopblock = 1;
                            rfid.cardinfo.nextopserno = (ulong)(rfid.cardinfo.account[0].serno + 1);
                    }
                    return OK;
            }
            //====================================
            private void rfid_getExpend()
            {
                    rfid.op.expend = 0;
                    if((rfid.cardinfo.expend[0].vailed != 0)
                            && ((Byte)(1+rfid.cardinfo.expend[0].serNo) == (Byte)rfid.cardinfo.nextopserno)
                       )
                    {
                            if( memcmpz(0,rfid.cardinfo.expend[0].Date ,0,rfid.op.DateTime,3) == 0)
                            {
                                    rfid.op.expend = rfid.cardinfo.expend[0].exsum;
                            }
                    }
                    else if((rfid.cardinfo.expend[1].vailed != 0)
                            && ((Byte)(1+rfid.cardinfo.expend[1].serNo) == (Byte)rfid.cardinfo.nextopserno)
                       )
                    {
                            if( memcmpz(0,rfid.cardinfo.expend[1].Date ,0,rfid.op.DateTime,3) == 0)
                            {
                                    rfid.op.expend = rfid.cardinfo.expend[1].exsum;
                            }
                    }
            }
            //==============================================================================
            private void rfid_wrStoreNo(Byte block, Byte[] buf)
            {
                memcpyz(0, buf, 0, rfid.op.realcardno, 6);
                memcpyz(6,buf,0, rfid.cardinfo.cardno, 2);
                memcpyz(8,buf,6,rfid.op.realcardno, 1);
                memcpyz(9,buf,0, rfid.op.ecrflag,5);
                memcpyz(14,buf,2, rfid.cardinfo.cardno, 2);
                des_enc(buf,0);
                des_enc(buf,8);
                RetVal=Mifs_Write(block, buf);
            }

            private Byte rfid_checkStoreNo(Byte[] buf)
            {
                    des_dec(buf,0);          //2
                    des_dec(buf,8);          //10
                    if((memcmpz(6,buf,0, rfid.cardinfo.cardno, 2) == 0)      // 校验卡号  //8
                            && (memcmpz(14,buf,2, rfid.cardinfo.cardno, 2) == 0))     // 校验卡号   //16
                    {
                            // 整理卡片信息
                            memcpyz(0,rfid.op.realcardno,0, buf, 6);         // 复制卡片实际卡号(1~6)   2
                            memcpyz(6,rfid.op.realcardno,8, buf, 1);        // 复制卡片实际卡号(7)     10
                            memcpyz(0,rfid.op.ecrflag,9, buf,5);            // 复制卡片ECR自定义    11
//                            MessageBox.Show("rcard" + rfid.op.realcardno[0].ToString() + "," + rfid.op.realcardno[1].ToString() + "," + rfid.op.realcardno[2].ToString());
                            return OK;
                    }
                    else
                    {
                            return ERROR;
                    }
            }

            // 将卡标志[5]设为"MCARD"
            // 将卡号及标志的第一个字节共8个字节加密
            Byte[] mcflag={0x4d,0x43,0x41,0x52,0x44};//"MCARD";
            private void ManaCardENC()
            {
                memcpyz(0,rfid.op.ecrflag,0,mcflag,5);//sizeof(rfid.op.ecrflag));
                memcpyz(0,buf,0,rfid.op.realcardno,7);//sizeof(rfid.op.realcardno));
                buf[7] = rfid.op.ecrflag[0];
                des_enc(buf,0);
                memcpyz(0, rfid.op.realcardno, 0, buf, 7);//sizeof(rfid.op.realcardno));
                rfid.op.ecrflag[0] = buf[7];
            }

            private void rfid_setkey(Byte sec, Byte[] buf)
            {
                Byte[] rfid_pwd_id = {0xff, 0x07, 0x80};
                Byte i;
                memcpyz(0, buf, 0, rfid.op.boss_pwd, 4);          // 商店老板的密码
                memcpyz(4,buf,0,rfid.cardinfo.cardno, 4);       // 系列号
                sec ^= 5;   //////!!!!!!!!!!!!!!
                for(i=0;i<8;i++)
                {
                    buf[i] ^= sec;
                }
                des_enc(buf,0);
                memcpyz(6,buf,0, rfid_pwd_id, 3);//sizeof(rfid_pwd_id));
                sec ^= 5;
                RetVal=Mifs_Write((Byte)(sec*4+3), buf);
            }


            private int ReadCardNoA(Byte[] CardNo)
            {
//                    int i;
                            rfid.retry=3;
//            Config:

                            RetVal=Mifs_Config();
//                MessageBox.Show("config"+RetVal.ToString());
                            if(RetVal==0)
                            {
//            Request:

                                    RetVal=Mifs_Request(1,buf);
                            }
                            else{
                                    /*if(--rfid.retry)
                                            goto Config;
                                    else*/
                                            return 11;;////rfid_exit(RFID_OP_STATUS_FATAL);
                            }
                            rfid.retry=3;

//                            MessageBox.Show("Request"+RetVal.ToString());
                            if (RetVal == 0)
                            {
 //           Anticol:

                                    RetVal=Mifs_Anticoll2(0, 0,buf);           // 防止碰撞
                            }
                            else{
                                    /*if(--rfid.retry)
                                            goto Request;
                                    else*/
                                            return 12;////rfid_exit(RFID_OP_STATUS_FATAL);//???
                            }
                            rfid.retry=3;

//                            MessageBox.Show("Anti"+RetVal.ToString());
                            if (RetVal == 0)
                            {
                                    memcpyz(0,rfid.cardinfo.cardno,0, buf, 4);           // 记录下卡号
                                    memcpyz(0, CardNo,0, rfid.cardinfo.cardno,4);           // 记录下卡号
                                    RetVal=Mifs_Select(buf,Size);
                                    return RetVal;
                            }
                            else
                            {
                                    /*if(--rfid.retry)
                                            goto Anticol;
                                    else*/
                                            return 13;
                            }
            }

            private int ReadCardAmountA(Byte[] sCardno, Byte[] MemNo, uint[] Opsn, uint[] Money)
            {
                    //int i;
                            if (RetVal == 0)
                            {
//            authsec:
                                    rfid_authsec(RFID_SECTOR0,buf,sCardno);
                            }
                            else
                            {
                                            return 14;//rfid_exit(RFID_OP_STATUS_FATAL);//???
                            }

                            if(RetVal==0)
                            {
//                                            if(rfid.op.CardDataVer == 0)
//                                                    memsetz((Byte[])rfid.op.expend,0,8);     //
//            readstore0:
                                            RetVal=Mifs_Read(RF_BLK_STORE_NO,buf);               // 读取卡号及自定义信息
                            }
                            else
                            {
                                            return 15;
                            }

                            if( (RetVal==0) &&
                                    (rfid_checkStoreNo(buf) == OK) )
                                    RetVal=Mifs_Read(RF_BLK_ACCOUNT_0,buf);                    // 读取金额0  Ret
                            else
                            {
                                            return 16;
                            }

                            rfid.retry=3;
            ReadSect0:
                            if(RetVal==0)
                            {
                                    if(rfid_checkAccount(buf) == OK)
                                    {
//                                            MessageBox.Show("0acnt" + buf[0].ToString() + "," + buf[1].ToString() + "," + buf[2].ToString() + "," + buf[3].ToString());
                                            rfid.cardinfo.account[0].account = (ulong)((buf[0]<<24) | (buf[1]<<16) | (buf[2]<<8) | buf[3]);//*((long *)&buf[0]);      // 取得金额 2
                                            rfid.cardinfo.account[0].serno = (ulong)((buf[6] << 24) | (buf[7] << 16) | (buf[14] << 8) | buf[15]);//(ulong)((buf[7] * (0x1000000) + buf[6] * (0x10000)) | (buf[15] * (0x100) + buf[14]));//((*((UINT16  *)&buf[6])) << 16) | (*((UINT16  *)&buf[14]));      // 取得操作系列号 8    16
                                            rfid.cardinfo.account[0].valid = 1;
//                                            MessageBox.Show("0s"+rfid.cardinfo.account[0].serno.ToString());
                                            RetVal=Mifs_Read(RF_BLK_ACCOUNT_1,buf);                    // 读取金额1
                                    }
                                    else
                                    {
                                            if(--rfid.retry>0)
                                            {

                                                    RetVal=Mifs_Read(RF_BLK_ACCOUNT_0,buf);
                                                    goto ReadSect0;
                                            }
                                            else
                                            {

                                                    RetVal=Mifs_Read(RF_BLK_ACCOUNT_1,buf);                    // 读取金额1
                                            }
                                    }
                            }
                            else
                            {
                                    return 17;
                            }
                            rfid.retry=3;

            ReadSect1:
                            if(RetVal==0)                               // 判定卡信息
                            {
                                    if(rfid_checkAccount(buf) == OK)
                                    {
//                                            MessageBox.Show("1acnt" + buf[0].ToString() + "," + buf[1].ToString() + "," + buf[2].ToString() + "," + buf[3].ToString());
                                        rfid.cardinfo.account[1].account = (ulong)((buf[0] << 24) | (buf[1] << 16) | (buf[2] << 8) | buf[3]);//*((long *)&buf[0]);      // 取得金额 2
                                        rfid.cardinfo.account[1].serno = (ulong)((buf[6] << 24) | (buf[7] << 16) | (buf[14] << 8) | buf[15]);//(ulong)((buf[7] * (0x1000000) + buf[6] * (0x10000)) | (buf[15] * (0x100) + buf[14]));//((*((UINT16  *)&buf[6])) << 16) | (*((UINT16  *)&buf[14]));      // 取得操作系列号 8    16
                                        rfid.cardinfo.account[1].valid = 1;
//                                            MessageBox.Show("1s" + rfid.cardinfo.account[1].serno.ToString());
                                        }
                                    if(rfid_getAccount() == OK)
                                    {
                                            rfid_getExpend();
            //				rfid_exit(RFID_OP_STATUS_OK);
                                            memcpyz(0, MemNo, 0, rfid.op.realcardno, 7);
                                            /*for(i=0;i<14;i++)
                                            {
                                                    if((MemNo[i]=='f')||(MemNo[i]=='F'))
                                                    {
                                                            MemNo[i]=0;
                                                            break;
                                                    }

                                            }*/
                                            Opsn[0] = (uint)rfid.cardinfo.nextopserno;
                                            Money[0] = (uint)rfid.op.account;
//                                            MessageBox.Show("acnt"+rfid.op.account.ToString());
                                            return 0;
                                    }
                                    else
                                    {
                                            if(--rfid.retry>0)
                                            {

                                                    RetVal=Mifs_Read(RF_BLK_ACCOUNT_1,buf);
                                                    goto ReadSect1;
                                            }
                                            else
                                            {
                                                    return 1;
                                            }
                                    }
                            }
                            else
                            {
                                    return 18;
                            }
            }

            private int ReadCardAmountB(Byte[] sCardno, Byte[] MemNo, uint[] Opsn, uint[] Money, Byte[] ecrflag)
            {
//                int i;
                if (RetVal == 0)
                {
//                authsec:
                    rfid_authsec(RFID_SECTOR0, buf, sCardno);
                }
                else
                {
                    return 14;//rfid_exit(RFID_OP_STATUS_FATAL);//???
                }

                if (RetVal == 0)
                {
//                    if (rfid.op.CardDataVer == 0)
//                        memsetz((Byte[])rfid.op.expend, 0, 8);     //
//                readstore0:
                    RetVal = Mifs_Read(RF_BLK_STORE_NO, buf);               // 读取卡号及自定义信息
                }
                else
                {
                    return 15;
                }

                if ((RetVal == 0) &&
                    (rfid_checkStoreNo(buf) == OK))
                    RetVal = Mifs_Read(RF_BLK_ACCOUNT_0, buf);                    // 读取金额0  Ret
                else
                {
                    return 16;
                }

                rfid.retry = 3;
            ReadSect0:
                if (RetVal == 0)
                {
                    if (rfid_checkAccount(buf) == OK)
                    {
                        rfid.cardinfo.account[0].account = (ulong)((buf[0] << 24) | (buf[1] << 16) | (buf[2] << 8) | buf[3]);//*((long *)&buf[0]);      // 取得金额 2
                        rfid.cardinfo.account[0].serno = (ulong)((buf[6] << 24) | (buf[7] << 16) | (buf[14] << 8) | buf[15]);//(ulong)((buf[7] * (0x1000000) + buf[6] * (0x10000)) | (buf[15] * (0x100) + buf[14]));//((*((UINT16  *)&buf[6])) << 16) | (*((UINT16  *)&buf[14]));      // 取得操作系列号 8    16
                        rfid.cardinfo.account[0].valid = 1;

                        RetVal = Mifs_Read(RF_BLK_ACCOUNT_1, buf);                    // 读取金额1
                    }
                    else
                    {
                        if (--rfid.retry>0)
                        {

                            RetVal = Mifs_Read(RF_BLK_ACCOUNT_0, buf);
                            goto ReadSect0;
                        }
                        else
                        {

                            RetVal = Mifs_Read(RF_BLK_ACCOUNT_1, buf);                    // 读取金额1
                        }
                    }
                }
                else
                {
                    return 17;
                }
                rfid.retry = 3;

            ReadSect1:
                if (RetVal == 0)                               // 判定卡信息
                {
                    if (rfid_checkAccount(buf) == OK)
                    {
                        rfid.cardinfo.account[1].account = (ulong)((buf[0] << 24) | (buf[1] << 16) | (buf[2] << 8) | buf[3]);//*((long *)&buf[0]);      // 取得金额 2
                        rfid.cardinfo.account[1].serno = (ulong)((buf[6] << 24) | (buf[7] << 16) | (buf[14] << 8) | buf[15]);//(ulong)((buf[7] * (0x1000000) + buf[6] * (0x10000)) | (buf[15] * (0x100) + buf[14]));//((*((UINT16  *)&buf[6])) << 16) | (*((UINT16  *)&buf[14]));      // 取得操作系列号 8    16
                        rfid.cardinfo.account[1].valid = 1;
                    }
                    if (rfid_getAccount() == OK)
                    {
                        rfid_getExpend();
                        //				rfid_exit(RFID_OP_STATUS_OK);
                        memcpyz(0, MemNo, 0, rfid.op.realcardno, 7);
                        /*for(i=0;i<14;i++)
                        {
                                if((MemNo[i]=='f')||(MemNo[i]=='F'))
                                {
                                        MemNo[i]=0;
                                        break;
                                }

                        }*/
                        Opsn[0] = (uint)rfid.cardinfo.nextopserno;
                        Money[0] = (uint)rfid.op.account;
                        memcpyz(0,ecrflag, 0,rfid.op.ecrflag, 5);
                        return 0;
                    }
                    else
                    {
                        if (--rfid.retry>0)
                        {

                            RetVal = Mifs_Read(RF_BLK_ACCOUNT_1, buf);
                            goto ReadSect1;
                        }
                        else
                        {
                            return 1;
                        }
                    }
                }
                else
                {
                    return 18;
                }
            }

            private int ReadManaCardA(ulong bpsw)
            {
//                    int i;
                            rfid.retry=3;
//            Config:

                            RetVal=Mifs_Config();
                            if(RetVal==0)
                            {
//            Request:

                                    RetVal=Mifs_Request(1,buf);
                            }
                            else{
                                    /*if(--rfid.retry)
                                            goto Config;
                                    else*/
                                            return 11;;////rfid_exit(RFID_OP_STATUS_FATAL);
                            }
                            rfid.retry=3;

                            if(RetVal==0)
                            {
//            Anticol:

                                    RetVal=Mifs_Anticoll2(0, 0,buf);           // 防止碰撞
                            }
                            else{
                                    /*if(--rfid.retry)
                                            goto Request;
                                    else*/
                                            return 12;////rfid_exit(RFID_OP_STATUS_FATAL);//???
                            }
                            rfid.retry=3;

                            if(RetVal==0)
                            {
                                    memcpyz(0,rfid.cardinfo.cardno,0, buf, 4);           // 记录下卡号
                                    RetVal=Mifs_Select(buf,Size);
                            }
                            else
                            {
                                    /*if(--rfid.retry)
                                            goto Anticol;
                                    else*/
                                            return 13;
                            }
                            rfid.retry=3;

                            if(RetVal==0)
                            {
//            authsec:
                                    rfid_authsec2(RFID_SECTOR0,buf,bpsw);
                            }
                            else
                            {
                                    /*if(--rfid.retry)
                                            goto Anticol;
                                    else*/
                                            return 14;//rfid_exit(RFID_OP_STATUS_FATAL);//???
                            }
                            rfid.retry=3;

                            if(RetVal==0)
                            {
//                                            if(rfid.op.CardDataVer == 0)
//                                                    memsetz(rfid.op.expend,0,8);     //
//            readstore0:

            //				RetVal=Mifs_Read(RF_BLK_STORE_NO,buf);               // 读取卡号及自定义信息
                                            return aclas_set_bosspsw(buf);
                            }
                            else
                            {
                                            return 15;
                            }
            }

            private int InitializeCardA(Byte[] sCardno)
            {
                Byte[] iniStr = { 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF };

                    RetVal=Mifs_AuthKey(0, RFID_SECTOR0,iniStr);
                    if(RetVal==0)
                    {
                            return AMiddle.aclas_auth_setkey(RF_BLK_SECT0_PWD,sCardno);
                    }
                    else
                            return 20;
            }

            private int ChkInitCardA(Byte[] sCardno)
            {
                rfid.op.newexpend = 0;
                rfid_authsec(RFID_SECTOR0, buf, sCardno);
                if (RetVal == 0)
                {
                    return 0;
                }
                else
                    return 21;
            }

            private int PublishCardA(Byte[] sCardno, Byte[] realCardno)
            {
                    rfid.op.newexpend=0;
                    rfid_authsec(RFID_SECTOR0,buf,sCardno);
                    if(RetVal==0)
                    {
                            rfid_wrAccount(RF_BLK_ACCOUNT_0,buf);
                    }
                    else
                            return 21;
                    if(RetVal==0)
                    {
                            memcpyz(0,buf_bck,0, buf, 16);      // 备份原来的数据
                            RetVal=Mifs_Read(RF_BLK_ACCOUNT_0,buf);           // 读取金额0
                    }
                    else
                            return 22;
                    if((RetVal==0)&&(memcmpz(0,buf, 0,buf_bck, 16)==0))   // 校验写入的数据   buf_bck[2]
                    {
                            rfid.cardinfo.nextopserno = 1;
                            rfid_wrAccount(RF_BLK_ACCOUNT_1,buf);
                    }
                    else
                            return 23;
                    if(RetVal==0)
                    {
                            memcpyz(0,buf_bck, 0,buf, 16);      // 备份原来的数据
                            RetVal=Mifs_Read(RF_BLK_ACCOUNT_1,buf);           // 读取金额1
                    }
                    else
                            return 24;
                    if((RetVal==0)&&(memcmpz(0,buf,0,buf_bck, 16)==0))   // 校验写入的数据   buf_bck[2]
                    {
                            memcpyz(0,rfid.op.realcardno,0,realCardno,7);
//                            MessageBox.Show("dcardn" + realCardno[0].ToString() + "," + realCardno[1].ToString() + "," + realCardno[2].ToString());
            /*                h=strlen(realCardno)/2;
                            for(i=0;i<h;i++)
                                    rfid.op.realcardno[i]=StrToInt("0x"+realCardno[2*i]+realCardno[2*i+1]);
                            m=strlen(realCardno)%2;
                            if(m>0)
                                    rfid.op.realcardno[h]=StrToInt("0x"+realCardno[2*h]+'F');
            */                rfid_wrStoreNo(RF_BLK_STORE_NO,buf);        // 写卡号及自定义信息
                    }
                    else
                            return 25;
                    if(RetVal==0)
                    {
                            memcpyz(0,buf_bck, 0,buf, 16);      // 备份原来的数据
                            RetVal=Mifs_Read(RF_BLK_STORE_NO,buf);            // 读取卡号及自定义信息
                    }
                    else
                            return 26;
                    if((RetVal==0)&&(memcmpz(0,buf,0, buf_bck, 16)==0))   // 校验写入的数据   buf_bck[2]
                    {
                            return  0;
                    }
                    else
                            return 27;
            }

            private int PublishCardB(Byte[] sCardno, Byte[] realCardno, Byte[] ecrflag)
            {
                rfid.op.newexpend = 0;
                rfid_authsec(RFID_SECTOR0, buf, sCardno);
                if (RetVal == 0)
                {
                    rfid_wrAccount(RF_BLK_ACCOUNT_0, buf);
                }
                else
                    return 21;
                if (RetVal == 0)
                {
                    memcpyz(0,buf_bck,0,buf, 16);      // 备份原来的数据
                    RetVal = Mifs_Read(RF_BLK_ACCOUNT_0, buf);           // 读取金额0
                }
                else
                    return 22;
                if ((RetVal == 0) && (memcmpz(0,buf, 0,buf_bck, 16) == 0))   // 校验写入的数据   buf_bck[2]
                {
                    rfid.cardinfo.nextopserno = 1;
                    rfid_wrAccount(RF_BLK_ACCOUNT_1, buf);
                }
                else
                    return 23;
                if (RetVal == 0)
                {
                    memcpyz(0,buf_bck,0,buf, 16);      // 备份原来的数据
                    RetVal = Mifs_Read(RF_BLK_ACCOUNT_1, buf);           // 读取金额1
                }
                else
                    return 24;
                if ((RetVal == 0) && (memcmpz(0,buf, 0,buf_bck, 16) == 0))   // 校验写入的数据   buf_bck[2]
                {
                    memcpyz(0,rfid.op.realcardno, 0,realCardno, 7);
                    memcpyz(0,rfid.op.ecrflag, 0,ecrflag, 5);
                    /*                h=strlen(realCardno)/2;
                                    for(i=0;i<h;i++)
                                            rfid.op.realcardno[i]=StrToInt("0x"+realCardno[2*i]+realCardno[2*i+1]);
                                    m=strlen(realCardno)%2;
                                    if(m>0)
                                            rfid.op.realcardno[h]=StrToInt("0x"+realCardno[2*h]+'F');
                    */
                    rfid_wrStoreNo(RF_BLK_STORE_NO, buf);        // 写卡号及自定义信息
                }
                else
                    return 25;
                if (RetVal == 0)
                {
                    memcpyz(0,buf_bck, 0,buf, 16);      // 备份原来的数据
                    RetVal = Mifs_Read(RF_BLK_STORE_NO, buf);            // 读取卡号及自定义信息
                }
                else
                    return 26;
                if ((RetVal == 0) && (memcmpz(0,buf, 0,buf_bck, 16) == 0))   // 校验写入的数据   buf_bck[2]
                {
                    return 0;
                }
                else
                    return 27;
            }

            private int InitialManaCardA(ulong bpsw)
            {
                Byte[] iniStr = { 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF };

                    rfid.op.boss_pwd[0]=HIBYTE(HIWORD(bpsw));
                    rfid.op.boss_pwd[1]=LOBYTE(HIWORD(bpsw));
                    rfid.op.boss_pwd[2]=HIBYTE(LOWORD(bpsw));
                    rfid.op.boss_pwd[3]=LOBYTE(LOWORD(bpsw));

                    RetVal=Mifs_AuthKey(0, RFID_SECTOR0,iniStr);
                    if(RetVal==0)
                    {
                            rfid_setkey(RFID_SECTOR0,buf);      //RF_BLK_SECT0_PWD
                            return RetVal;
                    }
                    else
                            return 20;
            }

            private int PublishManaCardA(ulong bpsw, Byte[] realCardno)
            {
                    rfid_authsec2(RFID_SECTOR0,buf,bpsw);
                    if(RetVal==0)
                    {
            //                TranCardNumToCardBCD( ManageKey);
                            memcpyz(0,rfid.op.realcardno,0,realCardno,7);
                            // 将卡标志[5]设为"MCARD"
                            // 将卡号及标志的第一个字节共8个字节加密
                            ManaCardENC();
                            rfid_wrStoreNo(RF_BLK_STORE_NO,buf);        // 写卡号及自定义信息
                            return RetVal;
                    }
                    else
                            return 30;
            }

            private int WriteCardA(uint[] Money)
            {
                                            rfid_wrAccount(((rfid.cardinfo.nextopblock == 0) ? RF_BLK_ACCOUNT_0 : RF_BLK_ACCOUNT_1),buf);
                                            if(RetVal==0)                               // 写信息
                                            {
                                                    memcpyz(0,buf_bck,0, buf, 16);      // 备份原来的数据   &buf[2]
                                                    memsetz(buf,0,16);
                                                    // 读取金额

                                                    RetVal=Mifs_Read((rfid.cardinfo.nextopblock == 0) ? RF_BLK_ACCOUNT_0 : RF_BLK_ACCOUNT_1,buf);
                                            }
                                            else
                                            {
            //					rfid_exit(RFID_OP_STATUS_FAIL);
                                                    return 2;
                                            }
                                            if((RetVal==0)&&(memcmpz(0,buf, 0,buf_bck, 16)==0))   // 校验写入的数据   buf_bck[2]
                                            {   // 写入的数据和读出的数据相同
            //					rfid_exit(RFID_OP_STATUS_OK);
                                                     Money[0] = (uint)rfid.op.account;
//                                                     MessageBox.Show("WrOK"+Money[0].ToString());
                                                     return 0;
                                            }
                                            else
                                            {
            //					rfid_exit(RFID_OP_STATUS_FAIL);
                                                    return 3;
                                            }
            }

            private void ReadWrite_Init()
            {
//                    memset(&rfid, 0, sizeof(rfid));
                rfid = new RFID_PROC_T(0, 0);
                rfid.retry = 3;
            }

            public int ReadManaCard(ulong bpsw)
            {
                ReadWrite_Init();
                return ReadManaCardA(bpsw);
            }

            public int ReadCardNo(Byte[] CardNo)
            {
                ReadWrite_Init();
                return ReadCardNoA(CardNo);
            }

            public int ReadCardAmount(Byte[] sCardno, Byte[] MemNo, uint[] Opsn, uint[] Money)
            {
                return ReadCardAmountA(sCardno, MemNo, Opsn, Money);
            }

            public int ReadCardAmountEcrflag(Byte[] sCardno, Byte[] MemNo, uint[] Opsn, uint[] Money, Byte[] ecrflag)
            {
                return ReadCardAmountB(sCardno,MemNo,Opsn,Money,ecrflag);
            }

            public int WriteCard(uint[] Money)     //var WriteInfo:TwriteInfo
            {
                rfid.op.newexpend = Money[0];
                return WriteCardA(Money);
            }

            public int PublishCard(Byte[] sCardno, Byte[] realCardno)
            {
                return PublishCardA(sCardno, realCardno);
            }

            public int PublishCardEcrflag(Byte[] sCardno, Byte[] realCardno, Byte[] ecrflag)
            {
                return PublishCardB(sCardno,realCardno,ecrflag);
            }

            public int InitializeCard(Byte[] sCardno)
            {
                return InitializeCardA(sCardno);
            }

            public int InitialManaCard(ulong bpsw)
            {
                return InitialManaCardA(bpsw);
            }

            public int PublishManaCard(ulong bpsw, Byte[] realCardno)
            {
                return PublishManaCardA(bpsw, realCardno);
            }

            public int ChkInitCard(Byte[] sCardno)
            {
                return ChkInitCardA(sCardno);
            }
        }
}
