﻿using System;
using System.Drawing;
using System.Windows.Forms;
using ACLAS;

namespace SleepModeDemo
{
    public partial class Form1 : Form
    {
        private PowerClass pwr = new PowerClass(); 

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Location = new Point ( (Screen.PrimaryScreen.WorkingArea.Width - Width)/2 , (Screen.PrimaryScreen.WorkingArea.Height - Height )/2);

            if (!pwr.Open())
            {
                MessageBox.Show("Open Power Driver Error!"); 
                Close();
            }
        }

        private void btGotoD1_Click(object sender, EventArgs e)
        {
            lbMode.Text = "Goto D1"; 
            pwr.SetPowerButtonSleepMode(PowerButtonSleepMode.GotoD1);
        }

        private void btGotoD2_Click(object sender, EventArgs e)
        {
            lbMode.Text = "Goto D2"; 
            pwr.SetPowerButtonSleepMode(PowerButtonSleepMode.GotoD2);
        }

        private void btGotoD3_Click(object sender, EventArgs e)
        {
            lbMode.Text = "Goto D3"; 
            pwr.SetPowerButtonSleepMode(PowerButtonSleepMode.GotoD3);
        }

        private void btDefault_Click(object sender, EventArgs e)
        {
            lbMode.Text = "Goto Default"; 
            pwr.SetPowerButtonSleepMode(PowerButtonSleepMode.Default);
        }

        private void btExit_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void Form1_Closed(object sender, EventArgs e)
        {
            pwr.Close(); 
        }
    }
}