﻿using System;
using System.Windows.Forms;
using ACLAS;

namespace TELCATDemo
{
    public partial class Form1 : Form
    {
        private TelCatClass telcat = null;
        

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            telcat = new TelCatClass();

            if (!telcat.open())
            {
                MessageBox.Show("TelCat Driver Open fail!");
                Close();
            }

            telcat.OnRingDetect += new EventHandler(telcat_OnRingDetect);
            telcat.OnCallIn += new EventHandler(telcat_OnCallIn);

        }

        void telcat_OnCallIn(object sender, EventArgs e)
        {
            this.Invoke(new TelCatCallBack(CallIn), new object[] { e }); 
        }

        void RingDetect(TelCatEventArgs args)
        {
            tbLog.Text += "Line:" + args.line + " RING\r\n"; 
        }

        void CallIn(TelCatEventArgs args)
        {
            tbLog.Text += "Line:" + args.line + " NO:" + args.PhoneNumber + "\r\n";
        }
        
        void telcat_OnRingDetect(object sender, EventArgs e)
        {
            this.Invoke(new TelCatCallBack(RingDetect) , new object[] { e });
        }

        private void btExit_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void Form1_Closed(object sender, EventArgs e)
        {
            if (telcat != null)
            {
                telcat.Close();  
            }
        }
    }
}