﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using ACLAS;
using System.Threading;

namespace TvoutTest
{
    public partial class Form1 : Form
    {
        private String[] TestMsg = new String[]
            {
                "即日起至100年12月28日,親持Living Card或刷京華卡，單筆消費滿3,000元，即可兌換300元商品券，另3月6日前京華卡友單筆刷600元，送毛寶抗菌洗手乳。12月6日起前在2、3樓專櫃單筆消費滿1000 元，有機會抽中SONY相機1台",
                "凡購買民生用品區、食品/保健區、休閒零食區、茶水飲料區、品牌專館:OPEN!PLAZA館之商品， 累計購物實際消費滿1,000元以上即可獲得100元折價券 (100元*1張)，最高可獲得500元折價券喔!",
                "夢時代跨年福袋來了,活動當日以現金1000元即可購買【幸福99福袋】或【好運100福袋】每人限購10袋。最大獎有Nissan Tida 1.8 5D B 轎車喔!!!"
            };

        private PayWindow Pay = new PayWindow();

        private int MovieIndex = 0;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // 注意, 窗體位置 Y 軸座標需 > 0 , 否則會有聲無影. 此問題有待解決.

            Location = new Point(0, 1); // <<-- 1 

            if (!TVout.Open())
            {
                MessageBox.Show("TV out Init Error!");  
                Close();
                return;
            }

            TVout.OnPlayMovieDone  +=new EventHandler(MovieDone); 
            TVout.InitMarquee(TestMsg, "Arial", Color.DarkRed, Color.White);

            Pay.Start();

            TVout.InitAD(@"\Program Files\tvouttest\AD"); 
        }

        private void PlayMovie()
        {
            switch (MovieIndex)
            {
                case 0:
                    TVout.PlayMovieInWindow(@"\Program Files\tvouttest\AD1.wmv");
                    break;
                default:
                    TVout.PlayMovieInWindow(@"\Program Files\tvouttest\AD2.wmv");
                    break;
            }
        }

        private void MovieDone(object sender, EventArgs e)
        {
            MovieIndex++;
            if (MovieIndex > 1) MovieIndex = 0;
            PlayMovie(); 
        }

        private void btPlay2_Click(object sender, EventArgs e)
        {
            MovieIndex = 1;
            PlayMovie(); 
        }

        private void btPlay1_Click(object sender, EventArgs e)
        {
            MovieIndex = 0;
            PlayMovie(); 
        }

        private void Form1_Closed(object sender, EventArgs e)
        {
            TVout.Close();
        }

        private void btQuit_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void btPause_Click(object sender, EventArgs e)
        {
            TVout.PausePlayMovie();  
        }

        private void btPlay_Click(object sender, EventArgs e)
        {
            TVout.RunPlayMovie();
        }

 
    }
}