﻿using System;
using System.Drawing;
using System.Windows.Forms;
using ACLAS;
using System.Threading;
using System.Runtime.InteropServices;
using System.Diagnostics;

namespace TvoutTest
{
    public partial class Form1 : Form
    {
#if WindowsCE
        static string applicationStartupPath = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().GetName().CodeBase);
#else
        static string applicationStartupPath = System.Windows.Forms.Application.StartupPath;
#endif

        // 打開驅動裝置類別
        PowerClass PwrDrawer = new PowerClass();

        System.Windows.Forms.Timer tmr = new System.Windows.Forms.Timer();

        private String[] TestMsg = new String[]
            {
                "即日起至100年12月28日,親持Living Card或刷京華卡，單筆消費滿3,000元，即可兌換300元商品券，另3月6日前京華卡友單筆刷600元，送毛寶抗菌洗手乳。12月6日起前在2、3樓專櫃單筆消費滿1000 元，有機會抽中SONY相機1台",
                "凡購買民生用品區、食品/保健區、休閒零食區、茶水飲料區、品牌專館:OPEN!PLAZA館之商品， 累計購物實際消費滿1,000元以上即可獲得100元折價券 (100元*1張)，最高可獲得500元折價券喔!",
                "夢時代跨年福袋來了,活動當日以現金1000元即可購買【幸福99福袋】或【好運100福袋】每人限購10袋。最大獎有Nissan Tida 1.8 5D B 轎車喔!!!"
            };

        private PayWindow Pay;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Location = new Point((Screen.PrimaryScreen.WorkingArea.Width - Width) / 2, (Screen.PrimaryScreen.WorkingArea.Height - Height) / 2);

            if (!PwrDrawer.Open())
            {
                MessageBox.Show("fail to open Power Driver!");
                Close();
                return;
            }

            if (!TVout.Open())
            {
                MessageBox.Show("TV out Init Error!");
                Close();
                return;
            }

            WINAPI.DebugMsg("p[1]");

            // 設定客顯窗口大小
            TVout.SetSize(1024, 768);

            // CPU 溫度監控
            tmr.Tick += new EventHandler(tmr_Tick);
            tmr.Interval = 1000;
            tmr.Enabled = true;

            lbTemp.Text = "--";

            // 內存洩漏監控
            DebugClass.Init(lbMemory);

            WINAPI.DebugMsg("p[2]");

#if true
            // 跑馬燈
            TVout.InitMarquee(0, 727, 1024, 40, 24, TestMsg, "Arial", Color.DarkRed, Color.White);

            // 交易窗口
            Pay = new PayWindow(1024);
            Pay.Start();

            // 廣告圖片播放
            TVout.InitAD(applicationStartupPath + "\\AD"); // Debug Path,Img in 'AD'

            // 設置廣告圖片播放參數
            TVout.SetupADPlay(530, 80, 480, 260, Color.YellowGreen, 3);
#endif
            WINAPI.DebugMsg("p[3]");
            // 打開播放功能
            MediaPlay.Open();

            WINAPI.DebugMsg("p[4]");

            // 設定大播放窗口的位置及大小
            MediaPlay.SetBigWindow(0, 60, 1024, 668);
            // 設定小播放窗口的位置及大小
            MediaPlay.SetSmallWindow(0, 60, 512, 334);

            // 播放檔案目錄
            MediaPlay.MediaPath = @"\Program Files\tvouttest\Video";
            //MediaPlay.MediaPath = @"\emmc\tvouttest\Video";
            //MediaPlay.MediaPath = @"\SDMemory\tvouttest\Video";
            WINAPI.DebugMsg("p[5]");
            // 添加到播放清單中,會自動依照添加的順序依次播放
#if false
            for (int i = 1; i < 9; i++)
            {
                WINAPI.DebugMsg("p[5]->" + i );
                string fn = "AD" + i + ".avi";
                MediaPlay.AddMedia(fn);
            }

            WINAPI.DebugMsg("p[6]");
#else

#if false
            for (int i = 5; i < 8; i++)
            {
                //MediaPlay.AddMedia("AD" + i + "_mpeg1video.mpg");
                MediaPlay.AddMedia("AD" + i + "_mpeg4.mp4");
            }
#else
            for (int i = 2; i < 5; i++)
            {
                MediaPlay.AddMedia("AD" + i + "_WMV V9.wmv");
            }
#endif
#endif

        }

        void tmr_Tick(object sender, EventArgs e)
        {
            byte temp = PwrDrawer.GetCpuTemp();
            if (temp != 0)
            {
                lbTemp.Text = temp.ToString();
            }
        }

        private void Form1_Closed(object sender, EventArgs e)
        {
            MediaPlay.Close();
            TVout.Close();
            PwrDrawer.Close();
        }

        private void btQuit_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void btPause_Click(object sender, EventArgs e)
        {
            MediaPlay.PauseMedia();
            // 覆蓋 Video 窗 非黑色 
            MediaPlay.VideoArea(0, 60, 1024, 668, Color.YellowGreen);
            TVout.RunADPlay();
        }

        private void btPlay_Click(object sender, EventArgs e)
        {
            if (MediaPlay.BigSize)
            {
                TVout.StopADPlay();
            }
            else
            {
                TVout.RunADPlay();
            }
            MediaPlay.PlayMedia();
        }

        private void btBig_Click(object sender, EventArgs e)
        {
            TVout.StopADPlay();
            MediaPlay.BigMedia();
        }

        private void btSmall_Click(object sender, EventArgs e)
        {
            MediaPlay.VideoArea(0, 60, 1024, 668, Color.YellowGreen);
            MediaPlay.SmallMedia();
            TVout.RunADPlay();
        }
    }
}