﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using ACLAS;

namespace WaitToD3
{
    public partial class Form1 : Form
    {
        private PowerClass m_pwr = new PowerClass();
        private bool run = false;

        private Timer tmr1 = new Timer();

        private Timer tmr2 = new Timer();

        private bool m_WaitD3 = false;

        private bool m_KeepWait = false;

        private int m_count;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Location = new Point((Screen.PrimaryScreen.WorkingArea.Width - Width) / 2, (Screen.PrimaryScreen.WorkingArea.Height - Height) / 2);

            if (!m_pwr.Open())
            {
                MessageBox.Show("Open Power Driver Error!");
                Close();
                return;
            }

            // 打開 Wait to D3 Mode
            if (!m_pwr.SetPowerWaitToD3Mode(true))
            {
                MessageBox.Show("This WINCE Version not support Wait to D3 Mode\r\nPlease update to new WINCE Version!");
                Close();
                return;
            }

            run = true;

            // 強制電源按鈕按下進入 D3
            m_pwr.SetPowerButtonSleepMode(PowerButtonSleepMode.GotoD3);
            // 指定電源變動 Call Back 處理
            m_pwr.OnPwrChange += new EventHandler(m_pwr_OnPwrChange);

            tmr1.Interval = 50;
            tmr1.Tick += new EventHandler(tmr_Tick);
            tmr1.Enabled = true;

            tmr2.Interval = 1000;
            tmr2.Tick += new EventHandler(tmr2_Tick);

        }

        void tmr2_Tick(object sender, EventArgs e)
        {
            --m_count;

            lbTime.Text = m_count.ToString();

            if (m_count == 0)
            {
                m_KeepWait = false;
                tmr2.Enabled = false;
                plD3Mode.Visible = false;
                // 通知 OS 請等待完畢可以進入 D3 了
                m_pwr.KeepWait = false;
            }
        }

        void tmr_Tick(object sender, EventArgs e)
        {
            if (m_pwr.KeepWait && !tmr2.Enabled)
            {
                m_count = 10;
                plD3Mode.Visible = true;
                lbTime.Text = m_count.ToString();
                tmr2.Enabled = true;
            }
        }

        // 請注意執行續安全問題
        void m_pwr_OnPwrChange(object sender, EventArgs e)
        {
            if (m_pwr.PowerEvent == PowerType.PowerWaitToD3)
            {
                // 通知 OS 請等待不要進入 D3
                m_pwr.KeepWait = true;
            }
        }
        
        private void Form1_Closed(object sender, EventArgs e)
        {
            if (run)
            {
                // 關掉 Wait to D3 Mode
                m_pwr.SetPowerWaitToD3Mode(false);  
                // 強制電源按鈕按下進入預設模式 (插電進 D2 否則進 D3)
                m_pwr.SetPowerButtonSleepMode(PowerButtonSleepMode.Default);
            }
            m_pwr.Close();  
        }



    }
}